
function pop = imtv_nnsdata(filename,tc_interval,hist_opt,bin)
%% imtv_nnsdata  Import NNS data
%       imtv_nnsdata(filename) loads the text data generated by NNS 
%       software which has been developed by Rybak Lab, Drexel University
%       and converts them to a structured data in Matlab with multiple time
%       cropping function.
%
%       This function needs 3 arguments: filename, hist_opt, bin
%       1. filename: NNS data file name (ASCII data)
%       2. tc_interval: interval time for multiple croppings
%       3. hist_opt: histogram option (1: generating histogram)
%                                     (2: generating histogram, remove neu)
%       4. bin: bin size for the histogram (usually 100)
%       
%       pop = imtv_nnsdata(...) returns a structured data of populations
%
%       If the histogram is not necessary, you can use only filename to run
%       this function. For the histogram option, cal_hist.m is needed.
%
%   Programmed by Taegyo Kim, Ph.D.
%   Rybak Lab, Neurobiology & Anatomy Department
%   Drexel University College of Medicine
%   Philadelphia, PA 19129, USA
%   10/12/2015 

if nargin == 1
    hist_opt = 0;
elseif nargin == 4
    bin = 100; %Default bin = 100;
end

%% Load a File

itmp = strfind(filename,'\');
n_itmp = length(itmp);
n_fn = length(filename);
pname = filename(1:itmp(n_itmp));
fname = filename(itmp(n_itmp)+1:n_fn);

clear itmp n_itmp n_fn;

disp(['======= Importing: ' fname ' =======']);
disp('Loading the text file ...');
fid = fopen(filename,'r');                   
scdata  = textscan(fid,'%s','delimiter',sprintf('\n'));
fclose(fid);

disp('The ASCII data was loaded.');

%% Parsing imported text data
disp('Extracting the recorded information ...');
% Version Extraction
tempc = strfind(scdata{1},'<Header>');
empty_idx = cellfun(@isempty,tempc);
tempc(empty_idx) = {0};
idx = find([tempc{:}] == 1);
if ~isempty(idx)
    temps = char(scdata{1}(idx+1));
    id = strfind(temps,'NNS');
    NSM_Version = temps(id:length(temps));
else
    NSM_Version = 'No Version Info.';
end
clear tempc idx empty_idx;

% Recorded Timing Info.

tempc = strfind(scdata{1},'Saved window');
empty_idx = cellfun(@isempty,tempc);
tempc(empty_idx) = {0};
idx = find([tempc{:}] == 1);
if ~isempty(idx)
    temps = char(scdata{1}(idx));
    id1 = strfind(temps,'[');
    id2 = strfind(temps, ',');
    id3 = strfind(temps, ']');
    t_wstart = str2double(temps(id1+1:id2-1));
    t_wend = str2double(temps(id2+1:id3-1));
    clear id1 id2 id3 temps;
end
clear tempc idx empty_idx;

tempc = strfind(scdata{1},'Duration');
empty_idx = cellfun(@isempty,tempc);
tempc(empty_idx) = {0};
idx = find([tempc{:}] == 1);
if ~isempty(idx)
    temps = char(scdata{1}(idx));
    id1 = strfind(temps,'=');
    id2 = strfind(temps, 'msec');
    rec_duration = str2double(temps(id1+2:id2-1));
end
clear tempc temps idx id1 id2 empty_idx;

tempc = strfind(scdata{1},'Precision');
empty_idx = cellfun(@isempty,tempc);
tempc(empty_idx) = {0};
idx = find([tempc{:}] == 1);
if ~isempty(idx)
    temps = char(scdata{1}(idx));
    id1 = strfind(temps,'=');
    id2 = strfind(temps, 'msec');
    rec_precision = str2double(temps(id1+2:id2-1));
end

clear tempc temps idx id1 id2 empty_idx;

% Population Info.
tempc = strfind(scdata{1},'<Spikes');
empty_idx = cellfun(@isempty,tempc);
tempc(empty_idx) = {0};
idx = find([tempc{:}] == 1);
if ~isempty(idx)
    n_pop = length(idx);
    i_pop = idx;
    clear idx;
    for i=1:n_pop
        temps = char(scdata{1}(i_pop(i)));
        id1 = strfind(temps,'>');
        popnames{i} = temps(9:id1-1);
        clear temps id1;
    end
end
clear tempc idx empty_idx i;

tempc = strfind(scdata{1},'</Spikes');
empty_idx = cellfun(@isempty,tempc);
tempc(empty_idx) = {0};
idx = find([tempc{:}] == 1);
if ~isempty(idx)
    i_npop = idx;
    clear idx;
end
clear tempc idx empty_idx i;

% Neuron Info.
tempc = strfind(scdata{1},'<Neuron');
empty_idx = cellfun(@isempty,tempc);
tempc(empty_idx) = {0};
idx = find([tempc{:}] == 1);
if ~isempty(idx)
    n_total_neu = length(idx);
    i_total_neu = idx;
end
clear tempc idx empty_idx;

tempc = strfind(scdata{1},'</Neuron');
empty_idx = cellfun(@isempty,tempc);
tempc(empty_idx) = {0};
idx = find([tempc{:}] == 1);
if ~isempty(idx)
    i_total_nneu = idx;   
end
clear tempc idx empty_idx;

% Neuron Data extraction
disp('Extracting neuron data ...');
t_total = rec_duration;
n_t = ceil(t_total / tc_interval);
for i=1:n_pop
    idx = find(i_total_neu > i_pop(i) & i_total_neu < i_npop(i));
    n_neu = length(idx);
    for j=1:n_neu
        tdata = str2double(scdata{1}(i_total_neu(idx(j))+1:i_total_nneu(idx(j))-1));
        for k=1:n_t
            tc_start(k) = (k-1)*tc_interval;
            tc_end(k) = tc_start(k) + tc_interval;
            i_tc = find(tdata > tc_start(k) & tdata <= tc_end(k));
            if ~isempty(i_tc)
                ttdata = tdata(i_tc) - tc_start(k);
            else
                ttdata = [];
            end
            neu{j,k} = ttdata;
            clear i_tc ttdata;
        end
        clear tdata;
    end
    disp(['Population ' num2str(i) ': ' popnames{i} ' , ' num2str(n_neu) ' neurons']);
    for k=1:n_t
        pop(k,i).NSM_Version = NSM_Version;
        pop(k,i).name = popnames{i};
        pop(k,i).size = n_neu;
        if exist('t_wstart','var')
            pop(k,i).t_wstart = t_wstart;
            pop(k,i).t_wend = t_wend;
        end
        pop(k,i).rec_precision = rec_precision;
        pop(k,i).rec_duration = tc_interval;

        pop(k,i).neu = neu(:,k);
        pop(k,i).tc_start = tc_start(k);
        pop(k,i).tc_end = tc_end(k);    
    end
    clear neu n_neu;
end

clearvars -except pop bin hist_opt n_pop tc_start tc_end n_t;

if hist_opt ~= 0
    disp('Generating histogram data ...');
    step = pop(1,1).rec_precision;
    
    for k=1:n_t
    
%         if isfield(pop(1,1),'t_wstart')
%             t_wstart = pop(1,1).t_wstart;
%             tn_start = int32(pop(1,1).t_wstart/step);
%             t_wend = pop(1,1).t_wend;
%             tn_end = int32(pop(1,1).t_wend/step);
%             n_hist = tn_end - tn_start;
%         else
            t_wstart = 0;
            tn_start = int32(0);
            t_wend = tc_end(k)-tc_start(k);
            tn_end = int32(t_wend/step);
            n_hist = tn_end;
%         end
        bin_h = bin/step;
        time = (t_wstart+step:step:t_wend)/1000;
        for i=1:n_pop
            disp(['Population ' num2str(i) ': ' pop(k,i).name ' hist, Window ' num2str(k)]);
            scale_factor = 1000 /(pop(k,i).size*bin);
            spk = zeros(n_hist,pop(k,i).size);
            for j=1:pop(k,i).size
                 temp = int32(pop(k,i).neu{j}/step);
                 if ~isempty(temp)
                     idx  = find(temp > tn_start & temp <= tn_end);
                     if ~isempty(idx)
                        temp = temp - tn_start;
                        spk(temp(idx),j) = 1;
                     end
                     clear temp idx;
                 end              
            end
            pop(k,i).hist = cal_hist(spk,bin_h,scale_factor);
            pop(k,i).n_neurons = cal_nneurons(spk,bin_h);
            pop(k,i).time = time;
            pop(k,i).scalef_4hist = scale_factor;
            pop(k,i).tspk = spk;
            clear spk scale_factor;

            if hist_opt == 2
                pop(k,i).neu = [];
            end

        end
    end
    
    if hist_opt == 2
        pop = rmfield(pop,'neu');
    end

end

disp('======= Importing & converting data was done =======');
disp('');

clearvars -except pop;


end